// Othello1.cpp: implementation of the COthello class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Othello.h"
#include "Othello1.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

COthello::~COthello()
{
player[1].Die();
player[0].Die();
}

bool COthello::Play (nMoveLocation move)
{
	bBusy = true;

	int t1, t2;

	
restart:

	if (move !=-1) Board.playmove(CurrentPlayer, move);
	//SendMessage(GetTopWindow

	t2 = Board.nLegalMoves(CurrentPlayer);
	
	CurrentPlayer = (CurrentPlayer==WHITE)? BLACK : WHITE;

	t1 = Board.nLegalMoves(CurrentPlayer);

	if (t1==0 && t2==0)
	{
		bBusy = false;
		return false;//code for game end
	}

	if (t1)
	{

		if (player[CurrentPlayer].getPlayerType() == HUMAN)
		{
			Board.MarkPossibleMoves(CurrentPlayer);
			bBusy = false; return true; }
		
		//tk: display computer is thinking
		
		//get computer move
		move = player[CurrentPlayer].getComputerMove(Board);

		goto restart;
	}
	else
	{
		move = -1; //indicated no move to play
		//MessageBox(GetTopWindow(), "No Moves to play! Click OK to Pass","Notice",MB_OK);

		goto restart;
	}
}
		
	

bool COthello::tryMove(nMoveLocation nLoc)
{
	bBusy = true;
	bool t = Board.isLegal(CurrentPlayer, nLoc);
	bBusy = false;
	return t;

}

nPos* COthello::getLastMoveSequence()
{
	return moveSequence;

}

void COthello::Set(CString p1Name, ePlayerType pType1, int nSD1, int nEGMT1, CString p2Name, ePlayerType pType2, int nSD2, int nEGMT2)
{
	player[BLACK].Set(pType1, nSD1, nEGMT1, BLACK, WHITE, NONE);
	player[WHITE].Set(pType2, nSD2, nEGMT2, WHITE, BLACK, NONE);
	player[BLACK].setName (p1Name);
	player[WHITE].setName (p2Name);


}

COthello::COthello()
{
	CurrentPlayer = BLACK;
	bBusy = false;
	nLastMoveLocation = -1;
}

ePlayerType COthello::getCurrentPlayerType()
{
	return player[CurrentPlayer].getPlayerType();
}

int COthello::GetResult()
{
	
	int t1 = Board.nPieces(BLACK);
	int t2 = Board.nPieces(WHITE);

	if (t1>t2) return BLACK;

	if (t1<t2) return WHITE;

	return NONE;
}

bool COthello::isBusy()
{
return bBusy;
}

void COthello::MarkPossibleMoves()
{
	Board.MarkPossibleMoves(CurrentPlayer);
}

nID COthello::GetCurrentPlayer()
{
	return CurrentPlayer;
}

nMoveLocation COthello::getComputerMove()
{
	return player[CurrentPlayer].getComputerMove(Board);

}

int COthello::nLegalMoves(nID who)
{
	return Board.nLegalMoves(who);


}

void COthello::playMove(nMoveLocation m)
{
	Board.playmove(CurrentPlayer, m);
	moveSequence=Board.getMoveSequence ();
	nLastMoveLocation = moveSequence [0];
}

nID COthello::switchPlayer()
{

	CurrentPlayer = (CurrentPlayer==WHITE)? BLACK : WHITE;
	return CurrentPlayer;
	
}

const char* COthello::getPlayerName()
{
	return getPlayerName(CurrentPlayer);
}

void COthello::resetGame()
{

	Board.Reset();
	CurrentPlayer=BLACK;
	nLastMoveLocation = -1;
	
}

nPos * COthello::getBoard()
{
	return Board.getBoard ();

}

bool* COthello::getListofPossibleMoves()
{
	return Board.getListofPossibleMoves();

}

long COthello::getElapsedTime()
{
	return player[CurrentPlayer].getElapsedTime();
}

long COthello::getNodesEvaluated()
{
	return player[CurrentPlayer].getNodesEvaluated();
}

nPos COthello::getLastMove()
{
	return nLastMoveLocation;

}

int COthello::nPieces(nID who)
{
	return Board.nPieces(who);
}

const char* COthello::getPlayerName(nID who)
{
	return (LPCTSTR) (player[who].getName());
}

nScore COthello::getCurrentScore()
{
	return player[CurrentPlayer].getCurrentScore();

}
