// PlayerSettings.cpp : implementation file
//

#include "stdafx.h"
#include "Othello.h"
#include "PlayerSettings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlayerSettings dialog


CPlayerSettings::CPlayerSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CPlayerSettings::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPlayerSettings)
	m_SearchDepth_A = -1;
	m_SearchDepth_B = -1;
	m_PerfectDepth_A = -1;
	m_PerfectDepth_B = -1;
	m_PlayerA = _T("");
	m_PlayerB = _T("");
	m_RadioPlayerBComputer = -1;
	m_RadioPlayerAComputer = -1;
	m_RadioPlayerAHuman = -1;
	m_RadioPlayerBHuman = -1;
	//}}AFX_DATA_INIT
	m_SearchDepth_A = 4;
	m_SearchDepth_B = 8;
	m_PerfectDepth_A = 4;
	m_PerfectDepth_B = 14;
	
	m_RadioPlayerAHuman = 0;
	m_RadioPlayerBComputer = 0;
	

	m_PlayerA = _T("You");
	m_PlayerB.Format ("Gothello", m_SearchDepth_A);
	
}


void CPlayerSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPlayerSettings)
	DDX_Control(pDX, IDC_COMBO_SELECT_SEARCH_DEPTH_PLAYER_B, m_ComboSearchB);
	DDX_Control(pDX, IDC_COMBO_SELECT_SEARCH_DEPTH_PLAYER_A, m_ComboSearchA);
	DDX_Control(pDX, IDC_COMBO_SELECT_PERFECT_SEARCH_DEPTH_PLAYER_B, m_ComboPerfectSearchB);
	DDX_Control(pDX, IDC_COMBO_SELECT_PERFECT_SEARCH_DEPTH_PLAYER_A, m_ComboPerfectSearchA);
	DDX_Control(pDX, IDC_EDIT_PLAYER_B_NAME, m_EditPlayerB);
	DDX_Control(pDX, IDC_EDIT_PLAYER_A_NAME, m_EditPlayerA);
	DDX_CBIndex(pDX, IDC_COMBO_SELECT_SEARCH_DEPTH_PLAYER_A, m_SearchDepth_A);
	DDX_CBIndex(pDX, IDC_COMBO_SELECT_SEARCH_DEPTH_PLAYER_B, m_SearchDepth_B);
	DDX_CBIndex(pDX, IDC_COMBO_SELECT_PERFECT_SEARCH_DEPTH_PLAYER_A, m_PerfectDepth_A);
	DDX_CBIndex(pDX, IDC_COMBO_SELECT_PERFECT_SEARCH_DEPTH_PLAYER_B, m_PerfectDepth_B);
	DDX_Text(pDX, IDC_EDIT_PLAYER_A_NAME, m_PlayerA);
	DDX_Text(pDX, IDC_EDIT_PLAYER_B_NAME, m_PlayerB);
	DDX_Radio(pDX, IDC_RADIO_PLAYER_B_COMPUTER, m_RadioPlayerBComputer);
	DDX_Radio(pDX, IDC_RADIO_PLAYER_A_COMPUTER, m_RadioPlayerAComputer);
	DDX_Radio(pDX, IDC_RADIO_PLAYER_A_HUMAN, m_RadioPlayerAHuman);
	DDX_Radio(pDX, IDC_RADIO_PLAYER_B_HUMAN, m_RadioPlayerBHuman);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPlayerSettings, CDialog)
	//{{AFX_MSG_MAP(CPlayerSettings)
	ON_BN_CLICKED(IDC_RADIO_PLAYER_A_COMPUTER, OnRadioPlayerAComputer)
	ON_BN_CLICKED(IDC_RADIO_PLAYER_A_HUMAN, OnRadioPlayerAHuman)
	ON_BN_CLICKED(IDC_RADIO_PLAYER_B_COMPUTER, OnRadioPlayerBComputer)
	ON_BN_CLICKED(IDC_RADIO_PLAYER_B_HUMAN, OnRadioPlayerBHuman)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlayerSettings message handlers

void CPlayerSettings::OnRadioPlayerAComputer() 
{
	// TODO: Add your control notification handler code here
	UpdateData (true);
	m_RadioPlayerAComputer = 0;
	m_RadioPlayerAHuman = -1;
	m_PlayerA = _T("Gothello");
	if(m_RadioPlayerBComputer == 0)
	{
		m_PlayerA += "A";
		m_PlayerB = "GothelloB";
	}
	m_EditPlayerA.EnableWindow(false);
	m_ComboPerfectSearchA.EnableWindow(true);
	m_ComboSearchA.EnableWindow(true);
	UpdateData (false);

	
}

void CPlayerSettings::OnRadioPlayerAHuman() 
{
	// TODO: Add your control notification handler code here
	UpdateData (true);
	m_RadioPlayerAComputer = -1;
	m_RadioPlayerAHuman = 0;
	m_PlayerA = _T("You");
	m_PlayerB = "Gothello";
	m_EditPlayerA.EnableWindow(true);
	m_ComboPerfectSearchA.EnableWindow(false);
	m_ComboSearchA.EnableWindow(false);
	UpdateData (false);

	
}

void CPlayerSettings::OnRadioPlayerBComputer() 
{
	// TODO: Add your control notification handler code here
	UpdateData (true);
	m_RadioPlayerBComputer = 0;
	m_RadioPlayerBHuman = -1;
	m_PlayerB = _T("Gothello");
	if(m_RadioPlayerAComputer == 0)
	{
		m_PlayerB += "B";
		m_PlayerA = "GothelloA";
	}
		
	m_EditPlayerB.EnableWindow(false);
	m_ComboPerfectSearchB.EnableWindow(true);
	m_ComboSearchB.EnableWindow(true);
	UpdateData (false);
	
}

void CPlayerSettings::OnRadioPlayerBHuman() 
{
	// TODO: Add your control notification handler code here
	UpdateData (true);
	m_RadioPlayerBComputer = -1;
	m_RadioPlayerBHuman = 0;
	m_PlayerB = _T("You");
	m_PlayerA = "Gothello";
	m_EditPlayerB.EnableWindow(true);
	m_ComboPerfectSearchB.EnableWindow(false);
	m_ComboSearchB.EnableWindow(false);
	UpdateData (false);

	
}

BOOL CPlayerSettings::OnInitDialog() 
{
	CDialog::OnInitDialog();
if (m_RadioPlayerAComputer == 0)
{
	m_EditPlayerA.EnableWindow(false);
	m_ComboPerfectSearchA.EnableWindow(true);
	m_ComboSearchA.EnableWindow(true);	
}
else 
{
	m_EditPlayerA.EnableWindow(true);
	m_ComboPerfectSearchA.EnableWindow(false);
	m_ComboSearchA.EnableWindow(false);	
}

if (m_RadioPlayerBComputer == 0)
{
	m_EditPlayerB.EnableWindow(false);
	m_ComboPerfectSearchB.EnableWindow(true);
	m_ComboSearchB.EnableWindow(true);	
}
else 
{
	m_EditPlayerB.EnableWindow(true);
	m_ComboPerfectSearchB.EnableWindow(false);
	m_ComboSearchB.EnableWindow(false);	
}

	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
